﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Networking.Proximity;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Basic Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234237

namespace Demo01.WindowsStore
{
    /// <summary>
    /// A basic page that provides characteristics common to most applications.
    /// </summary>
    public sealed partial class MainPage : Demo01.WindowsStore.Common.LayoutAwarePage
    {
        private ProximityDevice device;

        public MainPage()
        {
            this.InitializeComponent();

            device = ProximityDevice.GetDefault();
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            device.SubscribeForMessage("Windows.Demo01", async (s, message) =>
                {
                    await Dispatcher.RunAsync(Windows.UI.Core.CoreDispatcherPriority.Normal, () =>
                        {
                            messageTextBlock.Text = message.DataAsString;
                        });
                });

            base.OnNavigatedTo(e);
        }
    }
}
