﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Networking.Proximity;
using Windows.Storage.Streams;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Basic Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234237

namespace Demo02
{
    /// <summary>
    /// A basic page that provides characteristics common to most applications.
    /// </summary>
    public sealed partial class MainPage : Demo02.Common.LayoutAwarePage
    {
        private ProximityDevice device;

        public MainPage()
        {
            this.InitializeComponent();

            device = ProximityDevice.GetDefault();
        }

        private void publishButton_Click(object sender, RoutedEventArgs e)
        {
            if (!string.IsNullOrWhiteSpace(contactTextBox.Text))
            {
                using (var writer = new DataWriter { UnicodeEncoding = UnicodeEncoding.Utf16LE })
                {
                    var uri = string.Format("skype:{0}?call", contactTextBox.Text);
                    writer.WriteString(uri);
                    var buffer = writer.DetachBuffer();
                    device.PublishBinaryMessage("WindowsUri:WriteTag", buffer, OnMessageTransmitted);

                    tapIcon.Visibility = Windows.UI.Xaml.Visibility.Visible;
                }
            }
        }

        async void OnMessageTransmitted(ProximityDevice device, long messageId)
        {
            device.StopPublishingMessage(messageId);

            await Dispatcher.RunAsync(Windows.UI.Core.CoreDispatcherPriority.Normal, async () =>
            {
                tapIcon.Visibility = Windows.UI.Xaml.Visibility.Collapsed;

                var message = new MessageDialog("Il contatto è stato pubblicato con successo sullo smart tag.",
                    "Registra contatto Skype");
                await message.ShowAsync();
            });
        }
    }
}
