﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using EasyCheckin.WindowsPhone.Resources;
using Windows.Networking.Proximity;
using Windows.Networking.Sockets;
using Windows.Storage.Streams;
using System.Threading.Tasks;
using System.Windows.Input;
using Microsoft.WindowsAzure.MobileServices;
using System.Diagnostics;

namespace EasyCheckin.WindowsPhone
{
    public partial class MainPage : PhoneApplicationPage
    {
        // Constructor
        public MainPage()
        {
            InitializeComponent();
        }

        private async void loginButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                // Effettua il login al Mobile Service.
                await App.MobileService.LoginAsync(MobileServiceAuthenticationProvider.Facebook);

                loginButton.Visibility = System.Windows.Visibility.Collapsed;
                Debug.WriteLine("Autenticato");

                await this.RefreshEventsAsync();
            }
            catch { }
        }

        private async Task RefreshEventsAsync()
        {
            // Recupera la lista degli eventi ordinati per data.
            var events = await (from ev in App.MobileService.GetTable<Event>()
                                where ev.Date >= DateTime.Now
                                orderby ev.Date descending
                                select ev).ToListAsync();

            eventsList.ItemsSource = events;
        }

        private void itemsList_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (eventsList.SelectedItem != null)
            {
                // Recupera l'elemento che è stato selezionato.
                var selectedEvent = eventsList.SelectedItem as Event;

                // Naviga verso la pagina con il dettaglio dell'evento.
                NavigationService.Navigate(new Uri("/EventPage.xaml?eventID=" + selectedEvent.Id, UriKind.Relative));

                eventsList.SelectedItem = null;
            }
        }
    }
}