﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace EasyCheckin.WindowsStore
{
    public class MasterKeyFilter : DelegatingHandler
    {
        private string masterKey;

        public MasterKeyFilter(string masterKey)
        {
            this.masterKey = masterKey;
        }

        protected override async Task<HttpResponseMessage> SendAsync(
            HttpRequestMessage request, CancellationToken cancellationToken)
        {
            // Aggiunge al messaggio la master key necessaria per essere autenticati come admin.
            request.Headers.Add("X-ZUMO-MASTER", masterKey);

            // Sends the actual request to the Mobile Service.
            var response = await base.SendAsync(request, cancellationToken);
            return response;
        }
    }
}
